//Raptor.cs
datablock AudioProfile(RaptorDrawSound)
{
   filename    = "./RaptorDraw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(RaptorHitSound)
{
   filename    = "./RaptorHit.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(RaptorExplosionParticle1)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.7 0.7 0.9 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(RaptorExplosionEmitter1)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RaptorExplosionParticle1";

   uiName = "Raptor Hit1";
};

datablock ParticleData(RaptorExplosionParticle2)
{
   dragCoefficient      = 1;
   gravityCoefficient   = -1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.1;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/Star1";
   colors[0]     = "0.9 0.3 0.9 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.15;
   sizes[1]      = 0.05;
};

datablock ParticleEmitterData(RaptorExplosionEmitter2)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 3.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RaptorExplosionParticle2";

   uiName = "Raptor Hit2";
};



datablock ExplosionData(RaptorExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 200;

   soundProfile = RaptorHitSound;

   particleEmitter = RaptorExplosionEmitter1;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = RaptorExplosionEmitter2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "2.0 1.0 2.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("Raptor",   '<bitmap:add-ons/Weapon_Raptor/CI_Raptor> %1',    '%2 <bitmap:add-ons/Weapon_Raptor/CI_Raptor> %1',0.75,1);
datablock ProjectileData(RaptorProjectile)
{
   directDamage        = 60;
   directDamageType  = $DamageType::Raptor;
   radiusDamageType  = $DamageType::Raptor;
   explosion           = RaptorExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 160;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Raptor Slice";
};


//////////
// item //
//////////
datablock ItemData(RaptorItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Raptor.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "The Raptor";



	iconName = "./icon_Raptor2";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = RaptorImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RaptorImage)
{
   // Basic Item properties
   shapeFile = "./Raptor.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = 0; //"0.7 1.2 -0.25";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RaptorItem;
   ammo = " ";
   projectile = RaptorProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = RaptorDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.2;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateTimeoutValue[4]			= 0.5;
	stateWaitForTimeout[4]		= true;

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.9;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};
function Raptorimage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function RaptorImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}


